#include <bits/stdc++.h>
using namespace std;

long long obsah_rezu(long long a, long long b, long long c, long long s) {
    // kolko ma kvader policok (i,j,k) takych ze i+j+k = s?
    // zaratame vsetky trojice s i,j,k >= 0
    long long odpoved = (s+1)*(s+2)/2;
    // odratame vsetky kde je nejaka suradnica privelka
    if (s >= a) odpoved -= (s-a+1)*(s-a+2)/2;
    if (s >= b) odpoved -= (s-b+1)*(s-b+2)/2;
    if (s >= c) odpoved -= (s-c+1)*(s-c+2)/2;
    // dvakrat sme odratali tie, kde su dve privelke
    if (s >= a+b) odpoved += (s-a-b+1)*(s-a-b+2)/2;
    if (s >= a+c) odpoved += (s-a-c+1)*(s-a-c+2)/2;
    if (s >= b+c) odpoved += (s-b-c+1)*(s-b-c+2)/2;
    return odpoved;
}

vector<long long> hranice_2d, hranice_3d;

long long obsah_vela_rezov(long long a, long long b, long long c, long long s) {
    // scita obsah_rezu pre 0..s-1
    long long odpoved = 0;
    for (unsigned i=0; i+1<hranice_3d.size(); ++i) {
        long long lo = hranice_3d[i], hi = min(s, hranice_3d[i+1]);
        if (hi - lo <= 3) {
            for (long long j=lo; j<hi; ++j) odpoved += obsah_rezu(a,b,c,j);
        } else {
            long long n = hi - lo;
            long long a0 = obsah_rezu(a,b,c,lo);
            long long a1 = obsah_rezu(a,b,c,lo+1);
            long long a2 = obsah_rezu(a,b,c,lo+2);
            odpoved += a0*n + (a1-a0)*n*(n-1)/2 + (a2-2*a1+a0)*((n*(n-1)*(n-2))/6);
        }
        if (hi == s) break;
    }
    return odpoved;
}

long long obsah_uhlopriecky(long long b, long long c, long long s) {
    // kolko ma obdlznik policok (j,k) takych ze j+k = s?
    long long odpoved = s + 1;
    if (s >= b) odpoved -= (s - b + 1);
    if (s >= c) odpoved -= (s - c + 1);
    return odpoved;
}

long long obsah_vela_uhlopriecok(long long b, long long c, long long s) {
    // scita obsah_uhlopriecky pre 0..s-1
    long long odpoved = 0;
    for (unsigned i=0; i+1<hranice_2d.size(); ++i) {
        long long lo = hranice_2d[i], hi = min(s, hranice_2d[i+1]);
        if (hi - lo <= 3) {
            for (long long j=lo; j<hi; ++j) odpoved += obsah_uhlopriecky(b,c,j);
        } else {
            long long n = hi - lo;
            long long a0 = obsah_uhlopriecky(b,c,lo);
            long long a1 = obsah_uhlopriecky(b,c,hi-1);
            odpoved += (a0 + a1) * n / 2;
        }
        if (hi == s) break;
    }
    return odpoved;
}

long long obsah_useku_uhlopriecok(long long b, long long c, long long lo, long long hi) {
    //cout << "obsah_useku_uhlopriecok " << b << " " << c << " " << lo << " " << hi << endl;
    return obsah_vela_uhlopriecok(b,c,hi) - obsah_vela_uhlopriecok(b,c,lo);
}

void vyries_rez(long long a, long long b, long long c, long long s, long long n) {
    long long ilo = max(0LL, s-b-c+2), ihi = min(a-1, s);
    //cout << "ilo " << ilo << " ihi " << ihi << endl;
    long long lo = ilo, hi = ihi+1;
    while (hi - lo > 1) {
        long long med = (lo + hi) / 2;
        // chceme i z intervalu [ilo, med)
        // tieto i zodpovedaju suctom [s-med+1, s-ilo+1)
        long long cur = obsah_useku_uhlopriecok(b, c, s-med+1, s-ilo+1);
        //cout << "cur " << cur << endl;
        if (cur < n) lo = med; else hi = med;
    }
    n -= obsah_useku_uhlopriecok(b, c, s-lo+1, s-ilo+1);
    //cout << "na konci lo " << lo << " hi " << hi << " nove n " << n << endl;
    long long i = lo;
    s -= i;
    long long jmin = max(0LL, s-c+1);
    long long j = jmin + n - 1;
    long long k = s - j;
    cout << i << " " << j << " " << k << "\n";
}

int main() {
    long long a, b, c, q; cin >> a >> b >> c >> q;

    set<long long> pomocne_hranice_3d = {0,a-1,b-1,c-1,a+b-2,a+c-2,b+c-2,a+b+c-3,a+b+c-2};
    hranice_3d = vector<long long>(pomocne_hranice_3d.begin(), pomocne_hranice_3d.end());
    set<long long> pomocne_hranice_2d = {0,b-1,c-1,b+c-2,b+c-1};
    hranice_2d = vector<long long>(pomocne_hranice_2d.begin(), pomocne_hranice_2d.end());

    /*
    for (long long s=0; s<=a+b+c-3; ++s) cout << obsah_rezu(a,b,c,s) << " ";
    cout << endl;
    for (long long s=0; s<=a+b+c-2; ++s) cout << obsah_vela_rezov(a,b,c,s) << " ";
    cout << endl;
    for (long long s=0; s<=b+c-2; ++s) cout << obsah_uhlopriecky(b,c,s) << " ";
    cout << endl;
    for (long long s=0; s<=b+c-1; ++s) cout << obsah_vela_uhlopriecok(b,c,s) << " ";
    cout << endl;
    */

    while (q--) {
        long long n; cin >> n;
        // najdi, v ktorom reze sme
        long long lo = 0, hi = a+b+c-2;
        while (hi - lo > 1) {
            long long med = (hi + lo) / 2;
            if (obsah_vela_rezov(a,b,c,med) < n) lo = med; else hi = med;
        }
        //cout << "index " << n << " prazdne rezy " << lo << endl;
        n -= obsah_vela_rezov(a,b,c,lo);
        //cout << "novy index " << n << endl;
        // najdi policko v ramci toho rezu
        vyries_rez(a,b,c,lo,n);
    }
}
